HDU 5313 Bipartite Graph(二分图染色+01背包水过)

8 篇文章 0 订阅

Problem Description
Soda has a bipartite graph with  n  vertices and  m  undirected edges. Now he wants to make the graph become a complete bipartite graph with most edges by adding some extra edges. Soda needs you to tell him the maximum number of edges he can add.

Note: There must be at most one edge between any pair of vertices both in the new graph and old graph.
 

Input
There are multiple test cases. The first line of input contains an integer  T   (1T100) , indicating the number of test cases. For each test case:

The first line contains two integers  n  and  m (2n10000,0m100000) .

Each of the next  m  lines contains two integer  u,v   (1u,vn,vu)  which means there's an undirected edge between vertex  u  and vertex  v .

There's at most one edge between any pair of vertices. Most test cases are small.
 

Output
For each test case, output the maximum number of edges Soda can add.
 

Sample Input
  
  
2 4 2 1 2 2 3 4 4 1 2 1 4 2 3 3 4
 

Sample Output
  
  
2 0
 

Source
 

Recommend
hujie   |   We have carefully selected several similar problems for you:   5315  5314  5312  5311  5310 
 




大致题意:

有n个点,m条边的二分图(可能不连通),问最多还能加多少条边变成完全二分图


思路:

显然每一连通块,都染成两种颜色,最后要尽量使两种颜色总数相同解才最优

显然有两种决策,不是染白就是染黑,01背包


dp[i][val]表示前i个连通块能染成同一色点数<=val的最大值

显然dp[scc][all/2]是最优解


#pragma comment(linker, "/STACK:1024000000,1024000000")
#include <iostream>
#include <cstring>
#include <cmath>
#include <queue>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <sstream>
#include <string>
#include <vector>
#include <cstdio>
#include <ctime>
#include <bitset>
#include <algorithm>
#define SZ(x) ((int)(x).size())
#define ALL(v) (v).begin(), (v).end()
#define foreach(i, v) for (__typeof((v).begin()) i = (v).begin(); i != (v).end(); ++ i)
#define REP(i,n) for ( int i=1; i<=int(n); i++ )
using namespace std;
typedef long long ll;
#define X first
#define Y second
typedef pair<ll,ll> pii;


const int N = 10000+100;
const int M = 100000+1000;
struct Edge{
        int v,nxt;
        Edge(int v = 0,int nxt = 0):v(v),nxt(nxt){}
}es[M*2];
int n,m;
int ecnt;
int head[N];
inline void add_edge(int u,int v){
        es[ecnt] = Edge(v,head[u]);
        head[u] = ecnt++;
        es[ecnt] = Edge(u,head[v]);
        head[v] = ecnt++;
}
int col[N];
int cnt[N][2];
int top;
int sum = 0;
void dfs(int u,int fa){
        col[u] = !col[fa];
        cnt[top][col[u]]++;
        for(int i = head[u];~i;i = es[i].nxt){
                int v = es[i].v;
                if(v == fa || col[v] != -1) continue;
                dfs(v,u);
        }
}
void ini(){
        REP(i,n) head[i] = col[i] = -1,cnt[i][0] = cnt[i][1] = 0;
        col[0] = top = sum = ecnt = 0;
}
int dp[2][N];
int main(){


        int T;
        cin>>T;
        while(T--){
                scanf("%d%d",&n,&m);
                ini();
                REP(i,m){
                        int u,v;
                        scanf("%d%d",&u,&v);
                        add_edge(u,v);
                }
                for(int i = n; i>= 1;i--){
                        if(col[i] != -1) continue;
                        top++;
                        dfs(i,0);
                        if(cnt[top][0] == 0 || cnt[top][1] == 0) {
                                cnt[top][0] = cnt[top][1] = 0;
                                top--;
                        }
                        else {
                                sum += cnt[top][0],sum += cnt[top][1];
                        }
                }

                int nd = n-sum;
                for(int i = 0;i <= sum/2;i++) dp[0][i] = 0;
                REP(i,top){
                        for(int j = 0; j <= sum/2; j++){
                                 dp[i&1][j] = -1;
                                if(j-cnt[i][0] >= 0 && dp[(i-1)&1][j-cnt[i][0]] != -1) dp[i&1][j] = dp[(i-1)&1][j-cnt[i][0]]+cnt[i][0];
                                if(j-cnt[i][1] >= 0 && dp[(i-1)&1][j-cnt[i][1]] != -1) {
                                                dp[i&1][j] = max(dp[(i-1)&1][j-cnt[i][1]]+cnt[i][1],dp[i&1][j]);
                        }
                }
                int minn,maxx = sum-dp[top&1][sum/2];
                int t = min(nd,maxx-dp[top&1][sum/2]);
                minn = dp[top&1][sum/2]+t;
                nd -= t;
                if(nd) minn += nd/2, maxx += nd/2 + (nd&1);
                printf("%d\n",minn*maxx-m);
        }
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值